<template>
  <section id="arena-fight-page">
    <div class="top-screen">
      <img
        v-if="pokemon.against.numero"
        :class=" `pokemon-sprite against ${pokemon.against.isBlinking ? 'isBlinking' : ''} ${!pokemon.against.isBlinking && pokemon.against.hpRemaining <= 0 ? 'isKo' : ''}`"
        :src="pokemon.against.numero && pokemon.against.numero < 650 ? require(`@/assets/pkmn/front/${pokemon.against.numero}.png`) : require(`@/assets/pkmn/front/substitute.png`)"
      />
      <div v-if="pokemon.against.hp" class="pokemon-info against">
        <p class="name">{{pokemon.against.name}}</p>
        <!-- <p class="lvl">{{pokemon.against.lvl}}</p> -->
        <div
          class="hp-bar"
          v-bind:style="{
            backgroundColor: pokemon.against.hpRemaining / pokemon.against.hp >= 0.50 ?  '#55F755' : (pokemon.against.hpRemaining / pokemon.against.hp >= 0.25)?  '#FFDB4A' : '#DE4942', 
            borderColor: pokemon.against.hpRemaining / pokemon.against.hp >= 0.50 ?  '#12B919' : (pokemon.against.hpRemaining / pokemon.against.hp >= 0.25)?  '#D7AC00' : '#BE2821',
            width: pokemon.against.hpRemaining / pokemon.against.hp <= 1 ? (pokemon.against.hpRemaining / pokemon.against.hp >= 0 ? `${96 *  pokemon.against.hpRemaining / pokemon.against.hp}px` : '0px') : '96px'
          }"
        ></div>
      </div>
      <img
        v-if="pokemon.mine.numero"
        :class="`pokemon-sprite mine ${pokemon.mine.isBlinking ? 'isBlinking' : ''} ${!pokemon.mine.isBlinking && pokemon.mine.hpRemaining <= 0 ? 'isKo' : ''}`"
        :src="pokemon.mine.numero && pokemon.mine.numero < 650 ? require(`@/assets/pkmn/back/${pokemon.mine.numero}.png`): require(`@/assets/pkmn/back/substitute.png`)"
      />
      <div v-if="pokemon.mine.hp" class="pokemon-info mine">
        <p class="name">{{pokemon.mine.name}}</p>
        <!-- <p class="lvl">{{pokemon.mine.lvl}}</p> -->
        <div
          class="hp-bar"
          v-bind:style="{
            backgroundColor: pokemon.mine.hpRemaining / pokemon.mine.hp >= 0.50 ?  '#55F755' : (pokemon.mine.hpRemaining / pokemon.mine.hp >= 0.25)?  '#FFDB4A' : '#DE4942', 
            borderColor: pokemon.mine.hpRemaining / pokemon.mine.hp >= 0.50 ?  '#12B919' : (pokemon.mine.hpRemaining / pokemon.mine.hp >= 0.25)?  '#D7AC00' : '#BE2821',
            width: pokemon.mine.hpRemaining / pokemon.mine.hp <= 1 ? (pokemon.mine.hpRemaining / pokemon.mine.hp >= 0 ? `${96 *  pokemon.mine.hpRemaining / pokemon.mine.hp}px` : '0px') : '96px'
          }"
        ></div>
        <p class="hp">
          <span class="remaining">{{pokemon.mine.hpRemaining > 0 ? pokemon.mine.hpRemaining : 0}}</span>
          <span>/</span>
          <span class="max">{{pokemon.mine.hp}}</span>
        </p>
      </div>
      <div class="text-box">
        <p></p>
      </div>
    </div>
    <div class="middle-screen"></div>
    <div class="bottom-screen">
      <!-- Main menu -->
      <div class="columns" v-if="currentScreen === screen.MAIN">
        <div class="column">
          <button
            :class="`button is-info is-large `"
            @click="currentScreen = screen.ATK"
            :disabled="isWaitingForServer"
          >
            <span class="icon is-medium">
              <font-awesome-icon icon="fist-raised" />
            </span>
            <span>Attacks</span>
          </button>
        </div>
        <div class="column">
          <button
            :class="`button is-link is-large `"
            @click="currentScreen = screen.PKMN"
            :disabled="isWaitingForServer"
          >
            <span class="icon is-medium">
              <font-awesome-icon icon="list" />
            </span>
            <span>Pokémons</span>
          </button>
        </div>
      </div>
      <div class="columns" v-if="currentScreen === screen.MAIN">
        <div class="column">
          <button
            :class="`button is-danger is-large `"
            @click="goback()"
            :disabled="isWaitingForServer"
          >
            <span class="icon is-medium">
              <font-awesome-icon icon="running" />
            </span>
            <span>{{runningText}}</span>
          </button>
        </div>
      </div>
      <!-- Atk menu -->
      <div class="columns" v-if="currentScreen === screen.ATK">
        <div class="column" v-for="(atk, index) in pokemon.mine.atks" :key="`atk-${index}`">
          <button
            :class="`button is-large ${atk.idTypePokemon && typeToColorBulma[atk.idTypePokemon.name] ? `is-${typeToColorBulma[atk.idTypePokemon.name]}` : 'is-white'}`"
            @click="attack(atk)"
          >
            <span class="icon is-medium">
              <font-awesome-icon icon="fist-raised" />
            </span>
            <span>
              <p>
                {{atk.name}}
                <span>{{atk.puissance}}💪 {{atk.precision}}🏹</span>
              </p>
            </span>
          </button>
        </div>
      </div>
      <div class="columns" v-if="currentScreen === screen.ATK">
        <div class="column">
          <button class="button is-danger is-large" @click="currentScreen = screen.MAIN">
            <span class="icon is-medium">
              <font-awesome-icon icon="backward" />
            </span>
            <span>Return</span>
          </button>
        </div>
      </div>
      <!-- Pkmn menu -->
      <div class="pkmns" v-if="currentScreen === screen.PKMN">
        <div
          v-for="(pkmn, index) in pokemons"
          :key="`pkmn-${index}`"
          :class="`pkmn ${pkmn.isSelected ? 'is-selected' : ''} ${pkmn.hpRemaining <= 0 ? 'is-ko' : ''}`"
          v-bind:style="{ pointerEvents: pkmn.hpRemaining <= 0 || pkmn.id === pokemon.mine.id ? 'none': 'auto' }"
          @click="changePkmn($event, index)"
        >
          <p>{{pkmn.name}}</p>
          <p>
            <span>{{pkmn.lvl}}</span>
            <span>
              <span class="remaining">{{pkmn.hpRemaining > 0 ? pkmn.hpRemaining : 0}}</span>
              <span>/</span>
              <span class="max">{{pkmn.hp}}</span>
            </span>
          </p>

          <img
            :src="pkmn.numero && pkmn.numero < 650 ? require(`@/assets/pkmn/front/${pkmn.numero}.png`): require(`@/assets/pkmn/front/substitute.png`)"
          />
          <div
            class="hp-bar"
            v-bind:style="{
              backgroundColor: pkmn.hpRemaining / pkmn.hp >= 0.50 ?  '#55F755' : (pkmn.hpRemaining / pkmn.hp >= 0.25)?  '#FFDB4A' : '#DE4942', 
              borderColor: pkmn.hpRemaining / pkmn.hp >= 0.50 ?  '#12B919' : (pkmn.hpRemaining / pkmn.hp >= 0.25)?  '#D7AC00' : '#BE2821',
              width: pkmn.hpRemaining / pkmn.hp <= 1 ? (pkmn.hpRemaining / pkmn.hp >= 0 ? `${96 *  pkmn.hpRemaining / pkmn.hp}px` : '0px') : '96px'
            }"
          ></div>
        </div>
      </div>
      <div class="columns" v-if="currentScreen === screen.PKMN">
        <div class="column">
          <button class="button is-danger is-large" @click="currentScreen = screen.MAIN">
            <span class="icon is-medium">
              <font-awesome-icon icon="backward" />
            </span>
            <span>Return</span>
          </button>
        </div>
      </div>
    </div>
  </section>
</template>

<script>
import router from "../router";
import WriteTextBox from "../helper/writeTextBox";

export default {
  name: "arena-fight-page",
  data: function() {
    return {
      typeToColorBulma: {
        Bug: "success",
        Dark: "dark",
        Dragon: "link",
        Electric: "warning",
        Fight: "warning",
        Fire: "danger",
        Flying: "light",
        Ghost: "light",
        Grass: "success",
        Ground: "warning",
        Ice: "info",
        Normal: "white",
        Psychic: "light",
        Rock: "warning",
        Steel: "grey",
        Unknow: "white",
        Water: "link"
      },
      screen: {
        MAIN: "main",
        ATK: "atk",
        PKMN: "pkmn"
      },
      currentScreen: "main",
      pokemon: {
        mine: {},
        against: {}
      },
      isWaitingForServer: false,
      pokemons: [],
      /** @type {boolean} Is clicked Running button */
      isRunning: false,
      /** @type {string} Text display in Running button */
      runningText: "Run"
    };
  },
  methods: {
    /** @type {function} Callback on click Running button */
    goback() {
      /** @type {number} Counter to display in text */
      let count = 3;

      /** @type {function} Time interval */
      const exec = () => {
        if (count < 1) {
          clearInterval(this.interval);
          this.isRunning = false;
          this.runningText = `Run`;
          return;
        } else {
          this.runningText = `Are you sure (${count}) ?`;
          count--;
        }
      };

      if (this.isRunning) {
        this.$socket.emit("run", this.$route?.params?.id);
        this.isWaitingForServer = true;
        this.writeTextBox.run(["Waiting for other player"]);

        clearInterval(this.interval);
        this.isRunning = false;
        this.runningText = `Run`;
      } else {
        /** @type {number} Run interval */
        this.interval = setInterval(() => exec(), 1000);

        /** Run first time function */
        exec();

        this.isRunning = true;
      }
    },
    attack(atk) {
      // this.pokemon.against.hpRemaining =
      //   this.pokemon.against.hpRemaining - Math.floor(Math.random() * 20);

      // this.pokemon.against.isBlinking = true;
      // setTimeout(() => {
      //   this.pokemon.against.isBlinking = false;
      //   this.$forceUpdate();
      //   if (this.pokemon.against.hpRemaining <= 0) {
      //     setTimeout(() => {
      //       this.pokemon.against = {
      //         id: Math.floor(Math.random() * 999) + 1,
      //         name: "Toto",
      //         numero: Math.floor(Math.random() * 250) + 1,
      //         lvl: Math.floor(Math.random() * 100) + 1,
      //         hp: {
      //           max: Math.floor(Math.random() * 100) + 1,
      //           remaining: Math.floor(Math.random() * 50) + 1
      //         }
      //       };
      //     }, 2500);
      //   }
      // }, 500); //Remove blinking

      this.currentScreen = this.screen.MAIN;
      this.isWaitingForServer = true;

      // this.writeTextBox.run(
      //   [
      //     `${this.pokemon.mine.name} use ${atk.name} !`,
      //     this.pokemon.against.hpRemaining <= 0
      //       ? `${this.pokemon.against.name} is KO!`
      //       : null,
      //     this.pokemon.mine.hpRemaining <= 0
      //       ? `${this.pokemon.mine.name} is KO!`
      //       : null,
      //     "What are you going to do ?"
      //   ].filter(x => x)
      // );
      let data = {
        lobby: this.$route?.params?.id,
        attack: atk
      };
      this.$socket.emit("attack", data);
    },
    changePkmn(event, index) {
      let data = {
        lobby: this.$route?.params?.id,
        pokemon: this.pokemons[index]
      };
      this.$socket.emit("change-pokemon", data);
      this.currentScreen = this.screen.MAIN;
      this.isWaitingForServer = true;
      this.writeTextBox.run(["Waiting for other player"]);
    }
  },
  computed: {},
  components: {},
  mounted() {
    this.writeTextBox = new WriteTextBox();

    /** Turn is resolved */
    this.$socket.on("turn-resolved", data => {
      console.log(
        this.pokemon.mine.id,
        data.lobby.activePokemon.id,
        this.pokemon.mine.hpRemaining,
        data.lobby.activePokemon.hpRemaining
      );
      if (
        this.pokemon.mine.id == data.lobby.activePokemon.id &&
        this.pokemon.mine.hpRemaining != data.lobby.activePokemon.hpRemaining
      ) {
        console.log("Im blnking !");
        this.pokemon.mine.isBlinking = true;
        this.$forceUpdate();
        setTimeout(() => {
          this.pokemon.mine.isBlinking = false;
          this.$forceUpdate();
        }, 1000); //Remove blinking
      }

      if (
        this.pokemon.against.id == data.lobby.foePokemon.id &&
        this.pokemon.against.hpRemaining != data.lobby.foePokemon.hpRemaining
      ) {
        this.pokemon.against.isBlinking = true;
        this.$forceUpdate();
        setTimeout(() => {
          this.pokemon.against.isBlinking = false;
          this.$forceUpdate();
        }, 1000); //Remove blinking
      }

      console.log(data);
      this.writeTextBox.run(data.dialog);
      this.isWaitingForServer = false;
      // this.pokemon.mine = {
      //   ...data.lobby.activePokemon,
      //   isBlinking:
      //     this.pokemon.mine.id == data.lobby.activePokemon.id &&
      //     this.pokemon.mine.hpRemaining != data.lobby.activePokemon.hpRemaining
      // };
      this.pokemons = data.lobby.pokemons.map(x => ({
        ...x,
        isSelected: false,
        atks: [{ ...x.idCapacity1 }, { ...x.idCapacity2 }],
        lvl: 100
      }));
      this.pokemon.mine = {
        ...data.lobby.activePokemon,
        isSelected: false,
        isBlinking:
          this.pokemon.mine.id == data.lobby.activePokemon.id &&
          this.pokemon.mine.hpRemaining != data.lobby.activePokemon.hpRemaining,
        atks: [
          { ...data.lobby.activePokemon.idCapacity1 },
          { ...data.lobby.activePokemon.idCapacity2 }
        ],
        lvl: 100
      };
      this.pokemon.against = {
        ...data.lobby.foePokemon,
        isBlinking:
          this.pokemon.against.id == data.lobby.foePokemon.id &&
          this.pokemon.against.hpRemaining != data.lobby.foePokemon.hpRemaining,
        atks: [
          { ...data.lobby.foePokemon.idCapacity1 },
          { ...data.lobby.foePokemon.idCapacity2 }
        ],
        lvl: 100
      };
      //this.writeTextBox.run([`New turn !`, "What are you going to do ?"]);
    });

    /** Match is ended */
    this.$socket.on("match-ended", data => {
      console.log(data.dialog);
      // this.isWaitingForServer = false;
      this.writeTextBox.run(data.dialog);
      setTimeout(() => {
        this.$socket.emit("leave-lobby", this.$route?.params?.id);
        router.push("/arena");
      }, 4000);
    });

    /** Match init */
    this.$socket.on("lobby-informations", data => {
      this.writeTextBox.run(["What are you going to do ?"]);
      this.isWaitingForServer = false;

      this.pokemons = data.myPokemons.map(x => ({
        ...x,
        isSelected: false,
        isBlinking: false,
        atks: [{ ...x.idCapacity1 }, { ...x.idCapacity2 }],
        lvl: 100
      }));
      this.pokemon.mine = { ...this.pokemons[0] };
      console.log(this.pokemon.mine);
      this.pokemon.against = {
        ...data.foePokemon,
        isBlinking: false,
        atks: [
          { ...data.foePokemon.idCapacity1 },
          { ...data.foePokemon.idCapacity2 }
        ],
        lvl: 100
      };
    });

    /** Get informations */
    this.pokemons = this.$socket.emit(
      "get-lobby-informations",
      this.$route?.params?.id
    );

    this.isWaitingForServer = true;
  },
  destroyed() {
    this.writeTextBox.destroy();
    this.$socket.off("turn-resolved");
    this.$socket.off("match-ended");
    this.$socket.off("lobby-informations");
  }
};
</script>


<style scoped lang="scss">
#arena-fight-page {
  .top-screen {
    position: relative;
    background-image: url("~@/assets/background-fight.png") !important;
    background-color: #77db82;
    .text-box {
      z-index: 999;
    }
    .pokemon-sprite {
      position: absolute;
      width: calc(96px * 2);
      height: calc(96px * 2);
      &.mine {
        bottom: 35px;
        left: 30px;
      }
      &.against {
        top: 30px;
        right: 35px;
      }
      &.isBlinking {
        animation: blink 0.5s 1;
      }
      &.isKo {
        // animation-delay: 5s;
        animation: 0.5s ko 1s forwards;
      }
    }
    .pokemon-info {
      position: absolute;
      background-repeat: no-repeat;
      background-size: 100% auto;
      background-position: center auto;
      &.against {
        width: calc(121px * 2);
        height: calc(30px * 2);
        background-image: url("~@/assets/pokemon-fight-against.png");
        top: 30px;
        left: 0;
        .name {
          top: 10px;
          left: 10px;
        }
        .lvl {
          right: 40px;
          top: 11px;
        }
        .hp-bar {
          width: 96px;
          height: 8px;
          background: #55f755;
          border-top: 2px solid;
          border-bottom: 2px solid;
          border-color: #12b919;
          top: 40px;
          left: 100px;
        }
      }
      &.mine {
        width: calc(120px * 2);
        height: calc(38px * 2);
        bottom: 95px;
        right: 0;
        background-image: url("~@/assets/pokemon-fight-mine.png");
        .name {
          top: 10px;
          left: 35px;
        }
        .lvl {
          right: 15px;
          top: 11px;
        }
        .hp {
          position: absolute;
          bottom: 2px;
          text-align: right;
          right: 5px;
        }
        .hp-bar {
          width: 96px;
          height: 8px;
          background: #55f755;
          border-top: 2px solid;
          border-bottom: 2px solid;
          border-color: #12b919;
          top: 40px;
          left: 124px;
        }
      }
      > p {
        position: absolute;
        word-break: break-all;
        width: 100%;
        font-family: PokemonGb;
      }
      p.name {
        text-align: left;
      }
      p.lvl {
        text-align: right;
      }
      .hp-bar {
        position: absolute;
        transition: 0.1s;
      }
    }
  }
  .bottom-screen {
    .button > span {
      p {
        display: flex;
        flex-direction: column;
        span {
          font-size: 0.5em;
          margin: 0;
          padding: 0;
          line-height: 1em;
        }
      }
    }
    .pkmns {
      height: calc(100% - (45px * 2));
      display: flex;
      justify-content: center !important;
      flex-direction: row !important;
      flex-wrap: wrap;
      overflow-y: auto !important;
      scrollbar-width: thin;
      div.pkmn {
        width: 50%;
        font-family: PokemonGb;
        padding: 0.95em 1.5em 0.5em 3em;
        text-align: left;
        height: calc((45px * 2) + 0.5em);
        background-repeat: no-repeat;
        background-size: 100% auto;
        background-position: bottom left;
        color: white;
        display: flex;
        justify-content: space-between;
        flex-direction: column;
        position: relative;
        cursor: pointer;
        background-image: url("~@/assets/pokemon-box4.png") !important;
        &.is-selected {
          background-image: url("~@/assets/pokemon-box2.png") !important;
        }
        &.is-ko {
          background-image: url("~@/assets/pokemon-box3.png") !important;
        }
        .hp-bar {
          width: 96px;
          height: 8px;
          background: #55f755;
          border-top: 2px solid;
          border-bottom: 2px solid;
          border-color: #12b919;
          left: 119px;
          top: 56px;
          position: absolute;
        }
        > p {
          &:first-child {
            padding: 0.5em 0 0 1.2em;
          }
          &:nth-child(2) {
            display: flex;
            justify-content: space-between;
            flex-direction: row;
          }
        }
        > img {
          position: absolute;
          top: 10px;
          left: 20px;
          width: 50px;
          image-rendering: auto;
        }
      }
    }
  }
}

@keyframes blink {
  0% {
    opacity: 1;
  }
  15% {
    opacity: 0;
  }
  30% {
    opacity: 1;
  }
  45% {
    opacity: 0;
  }
  60% {
    opacity: 1;
  }
  75% {
    opacity: 0;
  }
  100% {
    opacity: 1;
  }
}

@keyframes ko {
  0% {
    opacity: auto;
  }
  60% {
    opacity: auto;
  }
  100% {
    opacity: 0;
  }
}
</style>
